#ifndef _KPILOTWINDOW_H_
#define _KPILOTWINDOW_H_

#include "frontend.h"
#include <iostream>
#include <string.h>
#include "kPilot2_shared.h"

#define KP_ZERO	0

const char WAWindowClass[] = "WAkPilotClass";
const char WAWindowName[] = "WAkPilotWindow";

#define		WINAMP_FILE_QUIT 40001
#define		WINAMP_OPTIONS_PREFS 40012
#define		WINAMP_OPTIONS_AOT 40019
#define		WINAMP_FILE_REPEAT 40022
#define		WINAMP_FILE_SHUFFLE 40023
#define		WINAMP_HIGH_PRIORITY 40025
#define		WINAMP_FILE_PLAY 40029
#define		WINAMP_OPTIONS_EQ 40036
#define		WINAMP_OPTIONS_ELAPSED 40037
#define		WINAMP_OPTIONS_REMAINING 40038
#define		WINAMP_OPTIONS_PLEDIT 40040
#define		WINAMP_HELP_ABOUT 40041
#define		WINAMP_MAINMENU 40043
#define		WINAMP_REWIND 40044					//
#define		WINAMP_PLAY 40045					//
#define		WINAMP_PAUSE 40046					//
#define		WINAMP_STOP 40047					//
#define		WINAMP_FASTFWD 40048				//
#define		WINAMP_VOLUMEUP 40058				//
#define		WINAMP_VOLUMEDOWN 40059				//
#define		WINAMP_FFWD5S 40060
#define		WINAMP_REW5S 40061
#define		WINAMP_NEXT_WINDOW 40063
#define		WINAMP_OPTIONS_WINDOWSHADE 40064
#define		WINAMP_REWIND_SHIFT 40144
#define		WINAMP_PLAY_SHIFT 40145
#define		WINAMP_PAUSE_SHIFT 40146
#define		WINAMP_STOP_SHIFT 40147
#define		WINAMP_FASTFWD_SHIFT 40148
#define		WINAMP_REWIND_CTRL 40154
#define		WINAMP_PLAY_CTRL 40155
#define		WINAMP_PAUSE_CTRL 40156
#define		WINAMP_STOP_CTRL 40157
#define		WINAMP_FASTFWD_CTRL 40158
#define		WINAMP_OPTIONS_DSIZE 40165
#define		IDC_SORT_FILENAME 40166
#define		IDC_SORT_FILETITLE 40167
#define		IDC_SORT_ENTIREFILENAME 40168
#define		IDC_SELECTALL 40169
#define		IDC_SELECTNONE 40170
#define		IDC_SELECTINV 40171
#define		IDM_EQ_LOADPRE 40172
#define		IDM_EQ_LOADMP3 40173
#define		IDM_EQ_LOADDEFAULT 40174
#define		IDM_EQ_SAVEPRE 40175
#define		IDM_EQ_SAVEMP3 40176
#define		IDM_EQ_SAVEDEFAULT 40177
#define		IDM_EQ_DELPRE 40178
#define		IDM_EQ_DELMP3 40180
#define		IDC_PLAYLIST_PLAY 40184
#define		WINAMP_FILE_LOC 40185
#define		WINAMP_OPTIONS_EASYMOVE 40186
#define		WINAMP_FILE_DIR 40187
#define		WINAMP_EDIT_ID3 40188
#define		WINAMP_TOGGLE_AUTOSCROLL 40189
#define		WINAMP_VISSETUP 40190
#define		WINAMP_PLGSETUP 40191
#define		WINAMP_VISPLUGIN 40192
#define		WINAMP_JUMP 40193
#define		WINAMP_JUMPFILE 40194
#define		WINAMP_JUMP10FWD 40195
#define		WINAMP_JUMP10BACK 40197

typedef struct tagKPILOTDATA
{
	int action;
	char Artist[128];
	char Title[128];
	char Duration[128];
	char Album[128];
	char FileName[128];
	char text[1024];
	int p0;
	long p1;
	double p2;
	int size;
} KPILOTDATA, *PKPILOTDATA;

class kPilotWindow
{
public:
	static int Init( HWND hWinamp, HINSTANCE hInstance );
	static int DeInit( );
private:
	static HWND m_hWnd;
	static HWND m_hWinamp;
	static HWND m_hClient;
	static HWND m_hPlayList;
	static WNDPROC m_OldWndProc;
	static int plugID;
private:
	static LRESULT CALLBACK WindowProc( HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam );
	static LRESULT CALLBACK PlayListProc( HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam );
	static KPILOTDATA TimeConvert(long);
	static void Distribute(kPilot2::sKPilot_base * pdata);
	static HWND GetClient();
	static void OnSongChange();
protected:
	static void CMDPlay();
	static void CMDPause();
	static void CMDStop();
	static void CMDNext();
	static void CMDPrev();
	static void CMDVolUp();
	static void CMDVolDown();
	static void CMDSetVolume(int lVal);
	static void CMDTrackDuration(kPilot2::sKPilot_Ex * pData);
	static void CMDTrackDuration(kPilot2::sKPilot_SongChange * pData);
	static void CMDTrackTime( kPilot2::sKPilot_Ex * pData );
	static void CMDTrackTimeRemain( kPilot2::sKPilot_Ex * pData );
	static void CMDTrackTimePercent( kPilot2::sKPilot_Ex * pData );
	static void CMDTrackTimePercentRemain( kPilot2::sKPilot_Ex * pData );
	static void CMDVersion( kPilot2::sKPilot_Ex * pData );
	static void CMDTrackName( kPilot2::sKPilot_SongChange * pData );
	static void CMDArtistName( kPilot2::sKPilot_SongChange * pData );
	static void CMDDiscName( kPilot2::sKPilot_SongChange * pData );
	static void CMDFileName( kPilot2::sKPilot_SongChange * pData );
	static void CMDPlayerStatus( kPilot2::sKPilot_Ex * pData );
	static int CMDGetVolume();
	static void CMDBitRate( kPilot2::sKPilot_Ex * pData );
	static void CMDFileSize( kPilot2::sKPilot_Ex * pData );
	static std::string FileSizeConvert( int size );
	static void Register();
};

#endif	//  _KPILOTWINDOW_H_