/////////////////////////////////////////////////////////////////////////////
//
// WMPkPilotInfoEvents.cpp : Implementation of CWMPkPilotInfo events
//
// Copyright (c) Microsoft Corporation. All rights reserved.
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "WMPkPilotInfo.h"

void CWMPkPilotInfo::OpenStateChange( long NewState )
{
    switch (NewState)
    {
    case wmposUndefined:
        break;
	case wmposPlaylistChanging:
        break;
	case wmposPlaylistLocating:
        break;
	case wmposPlaylistConnecting:
        break;
	case wmposPlaylistLoading:
        break;
	case wmposPlaylistOpening:
        break;
	case wmposPlaylistOpenNoMedia:
        break;
	case wmposPlaylistChanged:
        break;
	case wmposMediaChanging:
        break;
	case wmposMediaLocating:
        break;
	case wmposMediaConnecting:
        break;
	case wmposMediaLoading:
        break;
	case wmposMediaOpening:
        break;
	case wmposMediaOpen:
        break;
	case wmposBeginCodecAcquisition:
        break;
	case wmposEndCodecAcquisition:
        break;
	case wmposBeginLicenseAcquisition:
        break;
	case wmposEndLicenseAcquisition:
        break;
	case wmposBeginIndividualization:
        break;
	case wmposEndIndividualization:
        break;
	case wmposMediaWaiting:
        break;
	case wmposOpeningUnknownURL:
        break;
    default:
        break;
    }
}

void CWMPkPilotInfo::PlayStateChange( long NewState )
{
    switch (NewState)
    {
    case wmppsUndefined:
        break;
	case wmppsStopped:
		kPilotInfo::OnStateChange( STOPPED );
        break;
	case wmppsPaused:
		kPilotInfo::OnStateChange( PAUSED );
        break;
	case wmppsPlaying:
		kPilotInfo::OnStateChange( PLAYING );
        break;
	case wmppsScanForward:
        break;
	case wmppsScanReverse:
        break;
	case wmppsBuffering:
        break;
	case wmppsWaiting:
        break;
	case wmppsMediaEnded:
        break;
	case wmppsTransitioning:
        break;
	case wmppsReady:
        break;
	case wmppsReconnecting:
        break;
	case wmppsLast:
        break;
    default:
        break;
    }
}

void CWMPkPilotInfo::AudioLanguageChange( long LangID )
{
}

void CWMPkPilotInfo::StatusChange()
{
}

void CWMPkPilotInfo::ScriptCommand( BSTR scType, BSTR Param )
{
}

void CWMPkPilotInfo::NewStream()
{
}

void CWMPkPilotInfo::Disconnect( long Result )
{
}

void CWMPkPilotInfo::Buffering( VARIANT_BOOL Start )
{
}

void CWMPkPilotInfo::Error()
{
    CComPtr<IWMPError>      spError;
    CComPtr<IWMPErrorItem>  spErrorItem;
    HRESULT                 dwError = S_OK;
    HRESULT                 hr = S_OK;

    if (m_spCore)
    {
        hr = m_spCore->get_error(&spError);

        if (SUCCEEDED(hr))
        {
            hr = spError->get_item(0, &spErrorItem);
        }

        if (SUCCEEDED(hr))
        {
            hr = spErrorItem->get_errorCode( (long *) &dwError );
        }
    }
}

void CWMPkPilotInfo::Warning( long WarningType, long Param, BSTR Description )
{
}

void CWMPkPilotInfo::EndOfStream( long Result )
{
}

void CWMPkPilotInfo::PositionChange( double oldPosition, double newPosition)
{
}

void CWMPkPilotInfo::MarkerHit( long MarkerNum )
{
}

void CWMPkPilotInfo::DurationUnitChange( long NewDurationUnit )
{
}

void CWMPkPilotInfo::CdromMediaChange( long CdromNum )
{
}

void CWMPkPilotInfo::PlaylistChange( IDispatch * Playlist, WMPPlaylistChangeEventType change )
{
    switch (change)
    {
    case wmplcUnknown:
        break;
	case wmplcClear:
        break;
	case wmplcInfoChange:
        break;
	case wmplcMove:
        break;
	case wmplcDelete:
        break;
	case wmplcInsert:
        break;
	case wmplcAppend:
        break;
	case wmplcPrivate:
        break;
	case wmplcNameChange:
        break;
	case wmplcMorph:
        break;
	case wmplcSort:
        break;
	case wmplcLast:
        break;
    default:
        break;
    }
}

void CWMPkPilotInfo::CurrentPlaylistChange( WMPPlaylistChangeEventType change )
{
    switch (change)
    {
    case wmplcUnknown:
        break;
	case wmplcClear:
        break;
	case wmplcInfoChange:
        break;
	case wmplcMove:
        break;
	case wmplcDelete:
        break;
	case wmplcInsert:
        break;
	case wmplcAppend:
        break;
	case wmplcPrivate:
        break;
	case wmplcNameChange:
        break;
	case wmplcMorph:
        break;
	case wmplcSort:
        break;
	case wmplcLast:
        break;
    default:
        break;
    }
}

void CWMPkPilotInfo::CurrentPlaylistItemAvailable( BSTR bstrItemName )
{
}

void CWMPkPilotInfo::MediaChange( IDispatch * Item )
{
}

void CWMPkPilotInfo::CurrentMediaItemAvailable( BSTR bstrItemName )
{
}

void CWMPkPilotInfo::CurrentItemChange( IDispatch *pdispMedia)
{
	kPilotInfo::OnSongChange( pdispMedia );
}

void CWMPkPilotInfo::MediaCollectionChange()
{
}

void CWMPkPilotInfo::MediaCollectionAttributeStringAdded( BSTR bstrAttribName,  BSTR bstrAttribVal )
{
}

void CWMPkPilotInfo::MediaCollectionAttributeStringRemoved( BSTR bstrAttribName,  BSTR bstrAttribVal )
{
}

void CWMPkPilotInfo::MediaCollectionAttributeStringChanged( BSTR bstrAttribName, BSTR bstrOldAttribVal, BSTR bstrNewAttribVal)
{
}

void CWMPkPilotInfo::PlaylistCollectionChange()
{
}

void CWMPkPilotInfo::PlaylistCollectionPlaylistAdded( BSTR bstrPlaylistName)
{
}

void CWMPkPilotInfo::PlaylistCollectionPlaylistRemoved( BSTR bstrPlaylistName)
{
}

void CWMPkPilotInfo::PlaylistCollectionPlaylistSetAsDeleted( BSTR bstrPlaylistName, VARIANT_BOOL varfIsDeleted)
{
}

void CWMPkPilotInfo::ModeChange( BSTR ModeName, VARIANT_BOOL NewValue)
{
}

void CWMPkPilotInfo::MediaError( IDispatch * pMediaObject)
{
}

void CWMPkPilotInfo::OpenPlaylistSwitch( IDispatch *pItem )
{
}

void CWMPkPilotInfo::DomainChange( BSTR strDomain)
{
}

void CWMPkPilotInfo::SwitchedToPlayerApplication()
{
}

void CWMPkPilotInfo::SwitchedToControl()
{
}

void CWMPkPilotInfo::PlayerDockedStateChange()
{
}

void CWMPkPilotInfo::PlayerReconnect()
{
}

void CWMPkPilotInfo::Click( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMPkPilotInfo::DoubleClick( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMPkPilotInfo::KeyDown( short nKeyCode, short nShiftState )
{
}

void CWMPkPilotInfo::KeyPress( short nKeyAscii )
{
}

void CWMPkPilotInfo::KeyUp( short nKeyCode, short nShiftState )
{
}

void CWMPkPilotInfo::MouseDown( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMPkPilotInfo::MouseMove( short nButton, short nShiftState, long fX, long fY )
{
}

void CWMPkPilotInfo::MouseUp( short nButton, short nShiftState, long fX, long fY )
{
}
