/*
 * Konnekt SDK (Software Development Kit)
 * 
 * Nagwek: kPilot2 Shared
 * Modyfikowany: 2004-09-22
 * Zgodny z wersj: 0.2.0.0
 * Info: Podstawowy nagwek.
 * 
 * rodowisko: MS Visual C++
 * 
 * http://www.kplugins.net
 * 
 * (C)2002-2004 Stamina, (C)2004 KPlugins
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! */

#ifndef KPILOT2SHAREDH
#define KPILOT2SHAREDH

/******************/
/* kPilot2 Window */
/******************/
const char WindowClass[] = "kPilot2";
const char WindowName[] = "kPilot2";

#define WM_KPILOT WM_USER+1

/*************************************************/
/* Wiadomoci uywane do inicjacji i rejestracji */
/*************************************************/

#define KP_INIT WM_KPILOT+1
/* SendMessage( hKpilot2, KP_INIT, (WPARAM)hWnd, 0 );
** Przy wczeniu playera wysyamy ten komunikat przekazujc
** w WPARAM uchwyt okna, ktre ma przyjmowa komunikaty.
** Zwraca:
** TRUE		-		jeeli odtwarzacz jest znany kPilot2
** FALSE	-		jelie nie to wysya te KP_REGISTER
** Zaraz po tym trzeba wysa poziom gonoci KP_GETVOLUME.
*/

#define KP_REGISTER WM_KPILOT+2
/* COPYDATASTRUCT cpd;
** cpd.dwData = 0;
** cpd.cbData = sizeof(sKPilot_Register);
** cpd.lpData = pRegister;
** SendMessage( hKpilot2, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cpd );
** cbData musi by by wypenione wielkoci przesyanej struktutry,
** w lpData przesyamy wskanik do struktury. Rejestrujemy si w kPilocie.
** kPilot2 bdzie pamita do momentu kiedy user sam usunie wpis.
*/

#define KP_MSG WM_KPILOT+100


/**********************************/
/* Wiadomoci wysyane do playera */
/**********************************/

#define KP_PLAY KP_MSG+1
/* SendMessage( hPlayer, KP_PLAY, 0, 0 );
** Po wysaniu tej wiadomoci player powininen zacz odtwarza utwr.
*/

#define KP_PAUSE KP_MSG+2
/* SendMessage( hPlayer, KP_PAUSE, 0, 0 );
** Po wysaniu tej wiadomoci player powininen wstrzyma odtwarzanie utworu.
*/

#define KP_STOP KP_MSG+3
/* SendMessage( hPlayer, KP_STOP, 0, 0 );
** Po wysaniu tej wiadomoci player powininen zatrzyma odtwarzanie utworu.
*/

#define KP_NEXT KP_MSG+4
/* SendMessage( hPlayer, KP_NEXT, 0, 0 );
** Po wysaniu tej wiadomoci player powininen zacz odtwarza kolejny utwr.
*/

#define KP_PREV KP_MSG+5
/* SendMessage( hPlayer, KP_PREV, 0, 0 );
** Po wysaniu tej wiadomoci player powininen zacz odtwarza poprzedni utwr.
*/

#define KP_VOLUP KP_MSG+6
/* SendMessage( hPlayer, KP_VOLUP, 0, 0 );
** Po wysaniu tej wiadomoci player powininen zwikszy gono.
** Decyzja o ile ma zwiksza naley do autora wtyczki.
** Ta wiadomoci jest wykorzystywana, gdy przyciski kPilota s w menu
** i gono jest wczona w konfiguracji.
*/

#define KP_VOLDOWN KP_MSG+7
/* SendMessage( hPlayer, KP_VOLUP, 0, 0 );
** Po wysaniu tej wiadomoci player powininen zmniejszy gono.
** Decyzja o ile ma zmniejsza naley do autora wtyczki.
** Ta wiadomoci jest wykorzystywana, gdy przyciski kPilota s w menu
** i gono jest wczona w konfiguracji.
*/


/**********************************************/
/* Wiadomoci WM_COPYDATA wysyane od kPilota */
/**********************************************/

#define KP_SETVOLUME KP_MSG+8
/* W COPYDATASTRUCT przekazywana jest struktura sKPilot_Ex,
** gdzie znajduje si nowa warto poziomu gonoci.
** Poziom gonoci zawiera si w przedziale od 0 do 100.
** Wtyczka powinna sama przeliczy do wymaganego przez
** odtwarzacz zakresu.
*/


/*******************************************************/
/* Wiadomoci po ktrych player ma odesa WM_COPYDATA */
/*******************************************************/

#define KP_GETVOLUME KP_MSG+9
/* ## Aktualny poziom gonoci. ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_Ex z wypenionymi polami: msgID, s_size,
** vol. W tym ostatnim znajduje si aktualny poziom
** gonoci przeliczony do zakresu 0 do 100. Wtyczka
** powinna sama przeliczy z wymaganego przez odtwarzacz
** zakresu do tego przedziau. Polu msgID musi
** by przypisane KP_GETVOLUME.
*/

#define KP_TRACKTIME KP_MSG+10	
/* ## Aktualny moment(czas) odtwarzanego utworu ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_Ex z wypenionymi polami: msgID, s_size,
** time, szTime. W szTime czas powininen znajdowa
** si w formacie mm:ss lub hh:mm:ss. Polu msgID musi
** by przypisane KP_TRACKTIME.
*/

#define KP_TRACKTIMEREMAIN KP_MSG+11				
/* ## Czas do koca utworu ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_Ex z wypenionymi polami: msgID, s_size,
** time, szTime. W szTime czas powininen znajdowa
** si w formacie mm:ss lub hh:mm:ss. Polu msgID musi
** by przypisane KP_TRACKTIMEREMAIN.
*/

#define KP_TRACKTIMEPERCENT KP_MSG+12
/* ## Ile procent ju odtworzono ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_Ex z wypenionymi polami: msgID, s_size,
** time, szTime. W time powinien znale si liczbowo
** procent, natomiast w szTime tekstowo. Polu msgID musi
** by przypisane KP_TRACKTIMEPERCENT.
*/

#define KP_TRACKTIMEPERCENTREMAIN KP_MSG+13
/* ## Ile procent do koca utworu ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_Ex z wypenionymi polami: msgID, s_size,
** time, szTime. W time powinien znale si liczbowo
** procent, natomiast w szTime tekstowo.  Polu msgID musi
** by przypisane KP_TRACKTIMEPERCENTREMAIN.
*/

#define KP_PLAYER KP_MSG+14
/* ## Nazwa i wersja playera ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_Ex z wypenionymi polami: msgID, s_size,
** szPlayer. Polu msgID musi by przypisane KP_PLAYER.
*/

#define KP_PLAYERSTATUS KP_MSG+16
/* ## Stan odtwarzacza ( Playing, Paused, Stopped ) ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_Ex z wypenionymi polami: msgID, s_size,
** status. W polu status powinna znajdowa si jedna
** z wartoci enum PlayerState. Polu msgID musi by
** przypisane KP_PLAYER.
*/

#define KP_GETINFO KP_MSG+17
/* ## Trzeba odesa KP_ONSONG ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_SongChange z wypenionymi wszystkimi polami.
** Polu msgID musi by koniecznie przypisane KP_ONSONG!
*/

#define KP_FILESIZE KP_MSG+18
/* ## Rozmiar odtwarzanego pliku ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_Ex z wypenionymi polami: msgID, s_size,
** szFileSize. Pole szFileSize powinno zawiera rozmiar
** odtwarzanego pliku bez MB, np. "5,36".
** Polu msgID musi by przypisane KP_FILESIZE.
*/

#define KP_BITRATE KP_MSG+19
/* ## BitRate odtwarzanego pliku ##
**
** W COPYDATASTRUCT powinna by przekazana struktura
** sKPilot_Ex z wypenionymi polami: msgID, s_size,
** szBitrate. Pole szBitrate powinno zawiera bitrate
** odtwarzanego pliku bez kb/s, np. "192".
** Polu msgID musi by przypisane KP_BITRATE.
*/


/**************************************/
/* Notyfikacje wysyane przez playera */
/**************************************/

#define KP_ONSONG 1			
/* ## Zmiana utworu ##
**
** Notyfikacja wysyana, kiedy dochodzi do zmiany
** utworu. W COPYDATASTRUCT powinna by przekazana
** struktura sKPilot_SongChange w wypenionymi
** wszystkimi polami. Polu msgID musi by
** przypisane KP_ONSONG.
*/

#define KP_ONSTATECHANGE 2
/* ## Zmiana stanu odtwarzacza ##
**
** Notyfikacja wysyana, kiedy dochodzi do zmiany
** utworu. W COPYDATASTRUCT powinna by przekazana
** struktura sKPilot_SongChange w wypenionymi
** wszystkimi polami. Polu msgID musi by
** przypisane KP_ONSONG.
*/

#define KP_LOG 3
/* ## Logowanie w konnekcie ##
**
** Jeeli chcemy, aby konnekt co zalogowa
** to wysyamy w COPYDATASTRUCT wypenion
** struktur sKPilot_Log. W polu Log wpisujemy
** to co ma wywietli, a polu msgID musi by
** przypisane KP_LOG.
**
** ACHTUNG:
** Logowane bd wiadomoci tylko z zarejestrowanego
** playera i aktualnie uywanego!
*/

#ifndef KPILOT2_PLAYERSTATE
#define KPILOT2_PLAYERSTATE
enum PlayerState
{
	PLAYING = 1,
	PAUSED,
	STOPPED
};
#endif // KPILOT2_PLAYERSTATE

namespace kPilot2
{
	/* Struktura podstawowa do przesyania danych */
	struct sKPilot_base
	{
		int msgID;		// Identyfikator wiadomoci wysyanej KP_*
		int s_size;		// Rozmiar struktury w bajtach

		sKPilot_base() : s_size(sizeof(sKPilot_base)) {}
		sKPilot_base( int msgId ) : msgID( msgId ), s_size(sizeof(sKPilot_base)) {}
	};

    /* T struktur odtwarza powinien wysa do kPilota w momencie zmiany utworu */
	struct sKPilot_SongChange : public sKPilot_base
	{
		char artist[256];		// Nazwa Artysty
		char title[256];		// Tytu utworu
		char album[256];		// nazwa albumu
		char filename[256];		// nazwa pliku
		char duration[32];		// dugo utworu w formacie mm:ss lub hh:mm:ss
		int status;				// stan odtwarzacza, jeden z enum PlayerState

		sKPilot_SongChange(){s_size = sizeof(sKPilot_SongChange);}
		sKPilot_SongChange( int msgId, const char* Artist, const char* Title, const char* Album, const char* FileName, const char* Duration )
			: sKPilot_base( msgId )
		{
			sprintf( artist, "%s", Artist );
			sprintf( title, "%s", Title );
			sprintf( album, "%s", Album );
			sprintf( filename, "%s", FileName );
			sprintf( duration, "%s", Duration ); 
			s_size = sizeof( sKPilot_SongChange );
		}
		sKPilot_SongChange( sKPilot_SongChange * pSongChange ) 
			: sKPilot_base( pSongChange->msgID )
		{*this = *pSongChange;s_size = sizeof( sKPilot_SongChange );}
	};

	/* Ta struktura przeznaczona jest do przesyania poziomu gonoci,
	czasu (liczba i string), nazwy odtwarzacza itp. */
	struct sKPilot_Ex : public sKPilot_base
	{
		int vol;					// Poziom gonoci; zakres: 0-100
		double time;				// Czas w sekundach
		char szTime[16];			// Czas w formacie mm:ss lub hh:mm:ss, w zalenoci od dugoci utworu
									// lub jeli jest to procent to razem ze znakiem procentw
		int status;					// Status odtwarzacz Playing/Paused/Stopped
		char szPlayer[64];			// Nazwa playera i wersja lub sama nazwa, np. FooBar2000 0.8.3
		char szBitrate[32];			// Bitrate np. 192
		char szFileSize[32];		// Rozmiar pliku np. 4,31
		sKPilot_Ex( int msgId, int Vol ) : sKPilot_base( msgId ), vol(Vol) {s_size=sizeof(sKPilot_Ex);}
		sKPilot_Ex( int msgId, int Time, const char* _szTime ) : sKPilot_base( msgId ), time(Time)
		{sprintf( szTime, "%s", _szTime );s_size=sizeof(sKPilot_Ex);}
		sKPilot_Ex( int msgId, const char* _szPlayer ) : sKPilot_base( msgId )
		{sprintf( szPlayer, "%s", _szPlayer);s_size=sizeof(sKPilot_Ex);}
		sKPilot_Ex() {s_size = sizeof(sKPilot_Ex);}
	};
    
	/* Struktura potrzebna do zarejestrowania nowego odtwarzacza w kPilocie */
	struct sKPilot_Register : public sKPilot_base
	{
		char PlayerName[64];		// Nazwa odtwarzacza
		sKPilot_Register(int msgId,  const char* name ) : sKPilot_base(msgId)
		{ sprintf( PlayerName, "%s", name); s_size = sizeof( sKPilot_Register ); }
		sKPilot_Register() {s_size = sizeof(sKPilot_Register);}
	};

	/* Struktura do logowania w oknie dev konnekta */
	struct sKPilot_Log : public sKPilot_base
	{
		char Log[1024];				// Tre jaka ma by umieszczona w konnekt.log
		sKPilot_Log( int msgId, const char* log ) : sKPilot_base(msgId)
		{ sprintf( this->Log, "%s", log); s_size = sizeof( sKPilot_Log ); }
		sKPilot_Log() { this->s_size = sizeof(sKPilot_Log); }
	};
}

#endif // KPILOT2SHAREDH
