#ifndef _KPILOTINFO_H_
#define _KPILOTINFO_H_

#define KP_STRVER WM_KPILOT+14					// Wersja playera (string)

#include "wmpplug.h"
#include <iostream>
#include "kPilot2_shared.h"

const char WMP9Class[] = "WMP9kPilotInfo";
const char WMP9Name[] = "WMP9kPilotInfo";

typedef struct tagKPILOTDATA
{
	int action;
	char Artist[128];
	char Title[128];
	char Duration[128];
	char Album[128];
	char FileName[128];
	char text[1024];
	int p0;
	long p1;
	double p2;
	int size;
} KPILOTDATA, *PKPILOTDATA;

class kPilotInfo
{
public:
	static BOOL Start(HINSTANCE hInstance, IWMPCore *pCore);
	static void Stop();
	static void OnSongChange(IDispatch * Item);
	static void OnSongChange();
	static void OnStateChange( PlayerState state );
private:
	static LRESULT CALLBACK WindowProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static void DistributeData( kPilot2::sKPilot_base * pdata );
	static HWND GetClient();
	static KPILOTDATA TimeConvert( double time );
	static std::string FileSizeConvert( const char* size );
	static void Register();
	static void Log( const char* format, ... );

	static HRESULT CMDPlay();
	static HRESULT CMDPause();
	static HRESULT CMDStop();
	static HRESULT CMDNext();
	static HRESULT CMDPrev();
	static HRESULT CMDVolumeUp();
	static HRESULT CMDVolumeDown();
	static HRESULT CMDGetVolume( long *plVolume );
	static HRESULT CMDSetVolume( long lVolume );
	static HRESULT CMDTrackTime( kPilot2::sKPilot_Ex * pData );
	static HRESULT CMDTrackTimeRemain( kPilot2::sKPilot_Ex * pData );
	static HRESULT CMDTrackTimePercent( kPilot2::sKPilot_Ex * pData );
	static HRESULT CMDTrackTimePercentRemain( kPilot2::sKPilot_Ex * pData );
	static HRESULT CMDPlayerVersion( kPilot2::sKPilot_Ex * pData );
	static HRESULT CMDPlayerStatus( kPilot2::sKPilot_Ex * pData );
	static HRESULT CMDFileSize( kPilot2::sKPilot_Ex * pData );
	static HRESULT CMDBitRate( kPilot2::sKPilot_Ex * pData);
protected:
	static HWND m_hWnd;
	static HWND m_hPilot;
	static CComPtr<IWMPCore> m_pCore;
	static UINT_PTR m_idTimer;
	static int plugID;
};

#endif // _KPILOTINFO_H_