/*
 * Konnekt SDK (Software Development Kit)
 * 
 * Nagwek: kPilot2 Shared
 * Modyfikowany: 2004-09-22
 * Zgodny z wersj: 0.2.0.0
 * Info: Podstawowy nagwek.
 * 
 * rodowisko: MS Visual C++
 * 
 * http://www.kplugins.net
 * 
 * (C)2002-2004 Stamina, (C)2004 KPlugins
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! */

#ifndef KPILOT2INPROC
#define KPILOT2INPROC

#include "konnekt/plug_export.h"

#ifndef KPILOT2_PLAYERSTATE
#define KPILOT2_PLAYERSTATE
enum PlayerState
{
	PLAYING = 1,
	PAUSED,
	STOPPED
};
#endif // KPILOT2_PLAYERSTATE

/*********************************/
/***		  EXAMPLE			**/
/*********************************/

/*
** Pobieramy tytu utworu:
** const char* title = Ctrl->IMessage(&kPilot2::skPilot2( kPilot2::ACTIONS::TITLE ) );
**
** Wstrzymujemy odtwarzanie utworu:
** Ctrl->IMessage(&kPilot2::skPilot2( kPilot2::ACTIONS::PAUSE ) );
**/

namespace kPilot2
{
	const int NET = 444;
	namespace im
	{ 
		const int IM_PLAYER = NET*1000+402;
	}

	namespace ACTIONS
	{
		const int act = NET*1000+500;
		const int ARTIST = act+1;							// zwraca const char*
		const int TITLE = act+2;							// zwraca const char*
		const int ALBUM = act+3;							// zwraca const char*
		const int FILENAME = act+4;							// zwraca const char*
		const int DURATION = act+5;							// Dugo utworu, zwraca const char*
		const int TRACKPOSITION = act+6;					// Aktualna pozycja, zwraca const char*
		const int TRACKPOSITIONREMAIN = act+7;				// Pozostay czas do koca utworu, zwraca const const char*
		const int TRACKPOSITIONPERCENT = act+8;				// Aktualna pozycja w procentach, zwraca const char*
		const int TRACKPOSITIONPERCENTREMAIN = act+9;		// Pozostay czas do koca utworu w procentach, zwraca const char*
		const int PLAYERSTATE = act+10;						// Zwraca int z jedn z wartoci PlayerState
		const int PLAYERNAME = act +11;						// zwraca const char*
		const int BITRATE = act + 12;						// zwraca const char*
		const int FILESIZE = act + 13;						// zwraca const char*
		const int PLAY = act+14;
		const int PAUSE = act+15;
		const int STOP = act + 16;
		const int NEXT = act + 17;
		const int PREV = act + 18;
	};

	class skPilot2 : public sIMessage_base
	{
	public:
		int act;
		skPilot2(int _act) : sIMessage_base( im::IM_PLAYER, NET, -1 ), act(_act) {
			s_size = sizeof(skPilot2);}
	};    
}

#endif // KPILOT2INPROC
